var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
// eslint-disable-next-line no-use-before-define
import React, { createContext as createReactContext, useContext as useReactContext, useEffect, useReducer } from 'react';
import { isObject } from '../utils';
import { EventBus } from '../useEventBus/eventBus';
/**
 * 创建一个hooks的context
 */
export default function createContextHook(useCustomHook, getters) {
    var initialState = {};
    var CustomHookContext = createReactContext(initialState);
    var eventBus = new EventBus();
    // 创建一个全局变量存储实时result，从创建起引用就不会变化
    var globalResult = {};
    var Provider = function (props) {
        var _a = props || {}, children = _a.children, restProps = __rest(_a, ["children"]);
        var hookResult = useCustomHook(__assign({}, restProps));
        globalResult.hookResult = hookResult;
        useEffect(function () {
            eventBus.publish('__hookContext__:getterHookChanged');
        }, [hookResult]);
        useEffect(function () {
            // 卸载时将globalResult清空掉，防止持续占内存
            return function () {
                delete globalResult.hookResult;
            };
        }, []);
        return React.createElement(CustomHookContext.Provider, { value: { hookResult: hookResult } }, children);
    };
    var useHook = function () {
        var hookResult = useReactContext(CustomHookContext).hookResult;
        return hookResult;
    };
    var resultGetters = Object.entries(getters || {}).reduce(function (prev, _a) {
        var _b;
        var _c = __read(_a, 2), name = _c[0], getter = _c[1];
        var useGetterHook = function () {
            var _a = __read(useReducer(function (prev, current) { return getNewGetterResult({ current: current, prev: prev, getter: getter }); }, getNewGetterResult({ current: globalResult.hookResult, prev: prev, getter: getter })), 2), result = _a[0], dispatch = _a[1];
            useEffect(function () {
                eventBus.subscribe("__hookContext__:getterHookChanged", function () {
                    dispatch(globalResult.hookResult);
                });
            }, []);
            return result;
        };
        return __assign(__assign({}, prev), (_b = {}, _b[name] = useGetterHook, _b));
    }, {});
    return __assign(__assign({ Provider: Provider }, resultGetters), { useHook: useHook });
}
function getNewGetterResult(_a) {
    var _b = _a === void 0 ? {} : _a, current = _b.current, getter = _b.getter, prev = _b.prev;
    var getterResult = getter ? getter(current, { wrapperState: wrapperState }) : current;
    if (typeof getterResult === 'function' && getterResult.__IS_GETTER_HOOK__) {
        var result = getterResult();
        if (!getterResult.type || prev === undefined) {
            return result;
        }
        if (getterResult.type === 'object') {
            return checkArrayShouldUpdate({ result: result, prev: prev }) ? result : prev;
        }
        else if (getterResult.type === 'array') {
            return checkObjShouldUpdate({ result: result, prev: prev }) ? result : prev;
        }
    }
    return getterResult;
}
function checkArrayShouldUpdate(_a) {
    var result = _a.result, prev = _a.prev;
    return Array.from(new Set(Object.keys(result).concat(Object.keys(prev || {})))).some(function (key) { return prev[key] !== result[key]; });
}
function checkObjShouldUpdate(_a) {
    var result = _a.result, prev = _a.prev;
    return Array.from(new Set(__spreadArray([], __read(result), false).concat(prev))).some(function (value, index) { return prev[index] !== result[index]; });
}
function wrapperState(result) {
    var getResult = function () { return result; };
    if (isObject(result)) {
        getResult = function () {
            return result || {};
        };
        getResult.type = 'object';
    }
    else if (Array.isArray(result)) {
        getResult = function () {
            return result || [];
        };
        getResult.type = 'array';
    }
    ;
    getResult.__IS_GETTER_HOOK__ = true;
    return getResult;
}
