var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import useMethods from '../useMethods';
export var arrayMethods = {
    set: function (state, value) { return (typeof value === 'function' ? value(state) : value); },
    push: function (state, value) {
        if (state === void 0) { state = []; }
        return __spreadArray(__spreadArray([], __read(state), false), [value], false);
    },
    pop: function (state) { return state.slice(0, -1); },
    slice: function (state, start, end) { return state.slice(start, end); },
    clear: function () { return []; },
    reverse: function (state) { return __spreadArray([], __read(state), false).reverse(); },
    concat: function (state) {
        var _a;
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        return (_a = __spreadArray([], __read(state), false)).concat.apply(_a, __spreadArray([], __read(args), false));
    },
    sort: function (state, callback) { return __spreadArray([], __read(state), false).sort(callback); },
    sortBy: function (state, _a) {
        if (state === void 0) { state = []; }
        var field = _a.field, _b = _a.order, order = _b === void 0 ? 'ASC' : _b;
        if (!order || !['ASC', 'DESC'].includes(order))
            throw new Error('order error');
        return __spreadArray([], __read(state), false).sort(function (a, b) { return (order === 'ASC' ? a[field] - b[field] : b[field] - a[field]); });
    },
    remove: function (state, value) {
        return state.filter(function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return (typeof value === 'function' ? !value.apply(void 0, __spreadArray([], __read(args), false)) : args[0] !== value);
        });
    },
    // 根据id移除数据，数据格式必需为[{ [idkey], ... }]
    removeById: function (state, id, idKey) {
        if (idKey === void 0) { idKey = 'id'; }
        return state.filter(function (v) { return v && v[idKey] !== id; });
    },
    removeIndex: function (state, value) { return state.filter(function (v, i) { return i !== value; }); },
};
/**
 * 当state为数组时，数据需要是immutable的，不方便使用push等方法直接操纵数据，此hook提供几个常用方法，修改可以自动触发渲染
 */
export default function useArray(initial) {
    var _a = __read(useMethods(arrayMethods, initial || []), 2), listData = _a[0], actions = _a[1];
    return [listData, actions];
}
