declare type AsyncFunction = (...args: any[]) => any | Promise<any>;
declare type Exector = (...args: any[]) => Promise<any>;
/**
 * 仅对异步函数做简单处理，返回一个新的函数和loading、result、error等状态
 * @param asyncFunction
 * @param options.immediate 是否组件加载时自动执行
 * @param options.onResult 请求成功返回数据的回调，一般情况下直接.then后处理即可，但有时候希望自动同步状态，则可以配置onResult方法
 * @param options.debounceTime 设置值时自动进行debounce处理
 */
export default function useAsync<A extends AsyncFunction>(asyncFunction: A, { immediate, onResult, debounceTime, }?: {
    immediate?: boolean;
    onResult?: (res: any) => void;
    debounceTime?: number;
}): [
    Exector,
    {
        result: any;
        error: any;
        loading: boolean;
        status: 'success' | 'loading' | 'idle' | 'fail' | 'mutate success';
        mutate: (...args: any[]) => any;
    }
];
export {};
