interface CountupProps {
    format?: string | ((progress: number) => string);
    step?: number;
    onStart?: () => void;
    onStep?: (countup: number, formatedCountup: string) => void;
    onFinished?: (countup: number, formatedCountup: string) => void;
    autoRun?: boolean;
    maxLength?: number;
    loopWhenEnd?: boolean;
}
declare type Status = 'idle' | 'running' | 'pause' | 'finished';
/**
 * 计时hooks，可以用于天、时、分、秒、毫秒的计时
 */
export default function useCountup({ onStart, onStep, onFinished, step, format, maxLength, autoRun, loopWhenEnd, }: CountupProps): {
    status: Status;
    formatedCountup: string;
    countup: number;
    start: () => void;
    stop: (reset?: any) => void;
    reset: () => void;
    getCurrentCountup: (startTime: any) => {
        countup: number;
        formatedCountup: string;
    };
};
export {};
