declare type DebunceFn = (...args: any[]) => any;
declare type Cancel = () => void;
interface DebounceFnOptions {
    cancelWhenDestroy?: boolean;
    leading?: boolean;
    trailing?: boolean;
}
/**
 * 处理一个函数返回防抖的函数
 * @param handler 需要进行防抖处理的函数
 * @param wait 等待时间
 * @param options.cancelWhenDestroy 是否在组件销毁时取消debounce
 * @param options.leading 是否在延迟开始前立即调用
 * @param options.trailing 是否在延迟结束后触发调用
 * @returns
 */
export default function useDebounceFn(handler: DebunceFn, wait?: number, options?: DebounceFnOptions): [DebunceFn, Cancel];
export {};
