var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { useRef, useMemo, useEffect } from 'react';
import { isNil } from '../utils';
/**
 * 处理一个函数返回防抖的函数
 * @param handler 需要进行防抖处理的函数
 * @param wait 等待时间
 * @param options.cancelWhenDestroy 是否在组件销毁时取消debounce
 * @param options.leading 是否在延迟开始前立即调用
 * @param options.trailing 是否在延迟结束后触发调用
 * @returns
 */
export default function useDebounceFn(handler, wait, options) {
    var _this = this;
    if (options === void 0) { options = {}; }
    var _a = options.cancelWhenDestroy, cancelWhenDestroy = _a === void 0 ? true : _a, _b = options.leading, leading = _b === void 0 ? false : _b, _c = options.trailing, trailing = _c === void 0 ? true : _c;
    var optionsRef = useRef({ wait: wait, cancelWhenDestroy: cancelWhenDestroy, leading: leading, trailing: trailing, fired: false });
    optionsRef.current = __assign(__assign({}, optionsRef.current), { wait: wait, cancelWhenDestroy: cancelWhenDestroy, leading: leading, trailing: trailing });
    var timer = useRef();
    var fnRef = useRef(handler);
    fnRef.current = handler;
    useEffect(function () {
        return function () {
            if (optionsRef.current.cancelWhenDestroy && timer.current) {
                clearTimeout(timer.current);
                timer.current = null;
            }
        };
    }, []);
    return useMemo(function () {
        var cancel = function () {
            timer.current && clearTimeout(timer.current);
        };
        var debounceFn = function () {
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            return new Promise(function (resolve, reject) {
                var cb = function (fire) { return __awaiter(_this, void 0, void 0, function () {
                    var _a, error_1;
                    return __generator(this, function (_b) {
                        switch (_b.label) {
                            case 0:
                                cancel();
                                timer.current = null;
                                if (!(fire && fnRef.current)) return [3 /*break*/, 4];
                                _b.label = 1;
                            case 1:
                                _b.trys.push([1, 3, , 4]);
                                _a = resolve;
                                return [4 /*yield*/, fnRef.current.apply(null, args)];
                            case 2:
                                _a.apply(void 0, [_b.sent()]);
                                return [3 /*break*/, 4];
                            case 3:
                                error_1 = _b.sent();
                                reject(error_1);
                                return [3 /*break*/, 4];
                            case 4: return [2 /*return*/];
                        }
                    });
                }); };
                if (!isNil(optionsRef.current.wait)) {
                    if (optionsRef.current.leading && !timer.current) {
                        cb(true);
                    }
                    cancel();
                    timer.current = setTimeout(function () {
                        cb(!!optionsRef.current.trailing);
                    }, optionsRef.current.wait);
                }
                else {
                    cancel();
                    cb(true);
                }
            });
        };
        return [debounceFn, cancel];
    }, []);
}
