var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { useState, useRef } from 'react';
import isEqual from 'lodash.isequal';
import cloneDeep from 'lodash.clonedeep';
/**
 * 在每次更新时进行深比较，并返回新的值
 * 深比较比较耗性能，慎用
 */
export default function useDeepCompare(value) {
    var _a = __read(useState({ value: value, isEqual: true }), 2), state = _a[0], setState = _a[1];
    var isEqualRef = useRef(true);
    if (value && !isEqual(value, state.value)) {
        isEqualRef.current = false;
        setState({ isEqual: false, value: cloneDeep(value) });
    }
    else if (isEqualRef.current && !state.isEqual) {
        setState(function (prevState) { return ({ isEqual: true, value: prevState.value }); });
    }
    return state;
}
