import { useEffect, useRef } from 'react';
/**
 * 带有上次数据的useEffect
 */
export default function useEffectWithPrev(effect, deps) {
    var prevRef = useRef(deps);
    useEffect(function () {
        if (!deps) {
            return effect(prevRef.current);
        }
        var prev = prevRef.current;
        prevRef.current = deps;
        if (deps.length !== prev.length || deps.some(function (dep, index) { return dep !== prev[index]; })) {
            return effect(prev);
        }
    });
}
