import { Options, HistoryStock } from './historyState';
export interface useHistoryRefOptions<Raw, Serialized = Raw> extends Options<Raw, Serialized> {
}
export interface Return<Raw, Serialized> {
    source: Raw;
    history: HistoryStock<Serialized>[];
    last: HistoryStock<Serialized>;
    undoList: HistoryStock<Serialized>[];
    redoList: HistoryStock<Serialized>[];
    canUndo: boolean;
    canRedo: boolean;
    undo(): void;
    redo(): void;
    clear(): void;
    push(newSource: Raw): void;
    reset(): void;
    getHistory: HistoryStock<any>[];
    getUndoList: HistoryStock<any>[];
    getRedoList: HistoryStock<any>[];
}
/**
 *
 * @param source
 * @param options
 * @returns
 */
export default function useHistoryRef<Raw, Serialized = Raw>(options?: useHistoryRefOptions<Raw, Serialized>): Return<Raw, Serialized>;
