var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { useEffect, useRef, useState, useMemo } from 'react';
/**
 * 方便使用setInterval的hook
 */
export default function useInterval(callback, time, _a) {
    if (time === void 0) { time = 300; }
    var _b = _a === void 0 ? {} : _a, _c = _b.autoRun, autoRun = _c === void 0 ? true : _c;
    var intervalFn = useRef();
    intervalFn.current = callback;
    var intervalId = useRef(null);
    var _d = __read(useState(false), 2), isRunning = _d[0], setIsRunning = _d[1];
    var _e = useMemo(function () {
        return {
            start: function () {
                intervalId.current = setInterval(function () {
                    intervalFn.current();
                    setIsRunning(true);
                }, time);
            },
            stop: function () {
                clearInterval(intervalId.current);
                intervalId.current = null;
                setIsRunning(false);
            },
        };
    }, [time]), start = _e.start, stop = _e.stop;
    useEffect(function () {
        autoRun && start();
        return function () {
            stop();
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, [time]);
    return {
        isRunning: isRunning,
        start: start,
        stop: stop,
    };
}
