declare type Id = string;
interface Item extends Record<string, any> {
    id: Id;
}
/**
 * 列表的多选hooks，选择，全选，已选
 * @param {array} items 所有id
 * @param {array} defaultSelecteds 当前已选中ids
 */
export default function useListChecked(items?: Item[], defaultSelecteds?: Id[]): {
    isAllChecked: boolean;
    checkedIds: string[];
    setChecked: (key: Id, checked: boolean) => void;
    toggleChecked: (key: Id, checked?: boolean) => void;
    toggleAllChecked: (checked?: boolean) => void;
    clearChecked: () => void;
    updateItems: (...args: any[]) => void;
};
export {};
