var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { useMemo, useState, useCallback } from 'react';
// 列表页以分组模式按需加载下一组，适用每个item各不相同情况。如首页装修/信息流
export default function useListSequenceLoad(listData, _a) {
    if (listData === void 0) { listData = []; }
    var _b = _a === void 0 ? {} : _a, _c = _b.groupSize, groupSize = _c === void 0 ? 3 : _c;
    var _d = __read(useState(1), 2), showGroupIdx = _d[0], setShowGroupIdx = _d[1]; // 当前动态加载的组
    var reset = useCallback(function () {
        setShowGroupIdx(1);
    }, []);
    // 可以渲染的组件列表
    return useMemo(function () {
        var nextRenderIndex = Math.max(showGroupIdx * groupSize, 0);
        var showList = listData.slice(0, Math.min(listData.length, nextRenderIndex));
        // 修改待渲染index到下一个
        var loadNextGroup = function () {
            setShowGroupIdx(function (prevIdx) { return (prevIdx * groupSize - 1 < listData.length ? prevIdx + 1 : prevIdx); });
        };
        return {
            showList: showList,
            isAllLoaded: nextRenderIndex >= listData.length,
            showfooterLoading: nextRenderIndex < listData.length,
            nextRenderIndex: nextRenderIndex,
            loadNextGroup: loadNextGroup,
            reset: reset,
        };
    }, [listData, showGroupIdx, reset]);
}
