var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useRef } from 'react';
import 'intersection-observer';
import useListViewData from '..';
var fetchParams = { pageNo: 1, pageSize: 5 };
var mockData = new Array(30).fill(0).map(function (v, i) { return ({ id: i, value: i }); });
var fetchData = function (params) {
    var query = __assign(__assign({}, fetchParams), (params || {}));
    return new Promise(function (resolve) {
        setTimeout(function () {
            var start = (query.pageNo - 1) * query.pageSize;
            var data = mockData.slice(start, start + query.pageSize);
            resolve({ data: data, total: mockData.length, hasMore: query.pageNo < +(mockData.length / query.pageSize).toFixed(0) });
        }, 500);
    });
};
export default function Demo() {
    var _a = useListViewData(fetchData, {
        autoLoad: true,
        initialQuery: { pageSize: 10 },
        isMerge: true,
    }), listData = _a.listData, loading = _a.loading, loadNextPage = _a.loadNextPage, hasMore = _a.hasMore;
    var rootRef = useRef();
    var targetRef = useRef();
    useEffect(function () {
        var io = new IntersectionObserver(function (entries) {
            entries.forEach(function (entry) {
                entry.isIntersecting && hasMore && loadNextPage();
            });
        }, {
            root: rootRef.current || null,
            rootMargin: "0px",
            threshold: 0,
        });
        io.observe(targetRef.current);
        return function () {
            io.disconnect();
        };
    }, [hasMore, loadNextPage]);
    return (React.createElement("div", null,
        React.createElement("h2", null, "\u6EDA\u52A8\u52A0\u8F7D\u793A\u4F8B"),
        React.createElement("div", { style: { border: 'solid 1px', height: '100px', overflow: 'scroll', padding: 0 }, ref: rootRef },
            React.createElement("ul", { style: { padding: 0 } }, listData.map(function (item, i) { return (React.createElement("li", { style: { listStyleType: 'none', borderBottom: 'solid 0.5px #bbb' }, key: i },
                "\u7B2C",
                item.value,
                "\u6761")); })),
            React.createElement("div", { ref: targetRef }, loading ? 'loading' : ''))));
}
