export interface QueryParams {
    pageNo: number;
    pageSize: number;
    query: Record<string, any>;
}
interface Options {
    isMerge?: boolean;
    autoLoad?: boolean;
    initialQuery?: {
        pageSize?: number;
        pageNo?: number;
    };
}
export declare type FetchFn = (query: QueryParams) => Promise<{
    data: any[];
    hasMore?: boolean;
    total?: number;
    [x: string]: any;
}>;
export declare const defaultInitialQuery: QueryParams;
/**
 * 处理列表数据的hooks
 */
export default function useListViewData(fetchFn: FetchFn, options?: Options): {
    current: any;
    total: any;
    pageTotal: any;
    hasMore: any;
    listData: any;
    query: any;
    loading: boolean;
    loadData: (params?: Record<string, any>) => Promise<unknown>;
    loadNextPage: () => Promise<unknown>;
    loadPrevPage: () => Promise<unknown>;
    clearQuery: () => void;
    reloadData: () => Promise<unknown>;
    setQuery: (...args: any[]) => void;
};
export {};
