import { useEffect, useRef } from 'react';
/**
 * 这个hooks 返回一个memo的值，可以使用compare函数与自身的上一次值做比较
 */
export default function useMemoCompare(nextValue, compare) {
    var previousRef = useRef();
    var isEqual = compare(previousRef.current, nextValue);
    useEffect(function () {
        if (!isEqual) {
            previousRef.current = nextValue;
        }
    });
    return isEqual ? previousRef.current : nextValue;
}
