import { useMemo, useRef } from 'react';
/**
 * 带有上次数据的useMemo
 */
export default function useMemoWithPrev(nextCreate, deps) {
    var prevRef = useRef({ deps: deps, value: undefined, nextCreate: nextCreate });
    prevRef.current.nextCreate = nextCreate;
    return useMemo(function () {
        var current = prevRef.current.nextCreate(prevRef.current.deps, prevRef.current.value);
        prevRef.current.deps = deps;
        prevRef.current.value = current;
        return current;
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, deps);
}
