export declare type Reducer = (...args: any[]) => any;
export interface Action {
    type: string;
    payload?: any;
    [x: string]: any;
}
export interface Dispatch {
    (actionName: string, ...args: any[]): void;
    (action: Action): void;
}
declare type MethodsReducer<S> = (state: S) => Record<string, Reducer>;
export declare type Methods = Record<string, Reducer>;
export interface BoundActionMethods extends Record<string, (...args: any[]) => void> {
    dispatch: Dispatch;
}
export default function useMethods<S>(methods: Methods | MethodsReducer<S>, initialState: S | (() => S)): [S, BoundActionMethods, Dispatch];
export {};
