import { Draft, PatchListener } from 'immer/dist/immer.d';
interface Action {
    type: string;
    payload?: any;
    [x: string]: any;
}
interface Reducer<S> {
    (state: Draft<S>, payload?: Action | any): void;
}
declare type Methods<S> = Record<string, Reducer<S>>;
interface Dispatch {
    (actionType: string, payload?: any): void;
    (action: Action): void;
}
export declare type Actions = {
    dispatch: Dispatch;
} & Exclude<Record<string, (payload?: any) => void>, 'dispatch'>;
interface Options {
    patchListener?: PatchListener;
}
export default function useMethodsImmer<S>(methods: Methods<S>, initialState: any, initializer?: any, Options?: Options): [S, Actions];
export {};
