import { BoundActionMethods } from '../useMethods';
declare type State = Record<string, any>;
declare type SetState = (nextState: any, merge?: boolean) => void;
declare type Reducers<S> = Record<string, (...args: any[]) => S>;
/**
 * 面向对象的useState，自动进行合并，基本可以认为等同于class组件的this.setState
 * @param initialState 约定必须是一个object
 * @param reducers 自定义reducers方法
 * @returns [state, setState, stateMethods]
 */
export default function useObjectState<S extends State>(initialState?: S, reducers?: Reducers<S>): [S, SetState, BoundActionMethods];
export {};
