import React from 'react';
import usePolling from '.';
var wait = function (ms) { return new Promise(function (resolve) { return setTimeout(resolve, ms); }); };
var fetchData = function () {
    return wait(400).then(function () {
        var num = Math.random();
        if (num > 0.3) {
            return Array.from('🙁😂🌝😏😎👍👌🚗')[~~(num * 8)];
        }
        else {
            throw Error('未成功，继续尝试中');
        }
    });
};
export default function Demo() {
    var _a = usePolling(fetchData, {
        interval: 500,
        retryCount: 2,
    }), result = _a.result, error = _a.error, pollingCount = _a.pollingCount, isPolling = _a.isPolling, startPolling = _a.startPolling, stopPolling = _a.stopPolling;
    var handleClick = function () {
        isPolling ? stopPolling() : startPolling();
    };
    return (React.createElement("div", null,
        React.createElement("button", { onClick: handleClick }, isPolling ? '停止轮询' : '点击开始轮询'),
        React.createElement("p", null,
            "pollingCount: ",
            pollingCount),
        React.createElement("p", null, isPolling ? 'polling...' : ''),
        React.createElement("p", null, error ? error.message : result)));
}
