var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
import { useCallback, useEffect, useRef, useState } from 'react';
/**
 * 轮询一个请求
 * @param callback
 * @param options
 * @returns
 */
var usePolling = function (callback, options) {
    var _a = options.interval, interval = _a === void 0 ? 3000 : _a, _b = options.retryCount, retryCount = _b === void 0 ? 0 : _b, onSuccess = options.onSuccess, onFail = options.onFail;
    // callback 是必填的
    if (!callback) {
        throw new Error('No callback provided to poll. ');
    }
    var _c = __read(useState({
        isPolling: false,
        data: undefined,
        error: null,
        pollingCount: 0,
    }), 2), _d = _c[0], isPolling = _d.isPolling, data = _d.data, error = _d.error, pollingCount = _d.pollingCount, setState = _c[1];
    var infoRef = useRef({
        isMounted: false,
        retryCount: retryCount,
    });
    infoRef.current.interval = interval;
    infoRef.current.isPolling = isPolling;
    infoRef.current.callback = callback;
    infoRef.current.onSuccess = onSuccess;
    infoRef.current.onFail = onFail;
    var stopPolling = function () {
        if (infoRef.current.pollTimer) {
            clearTimeout(infoRef.current.pollTimer);
            infoRef.current.pollTimer = null;
        }
        if (infoRef.current.isMounted) {
            setState(function (prev) { return (__assign(__assign({}, prev), { isPolling: false })); });
        }
    };
    var runPolling = useCallback(function () {
        infoRef.current.pollTimer = setTimeout(function () { return __awaiter(void 0, void 0, void 0, function () {
            var _a, callback, onSuccess, onFail, isPolling;
            return __generator(this, function (_b) {
                _a = infoRef.current, callback = _a.callback, onSuccess = _a.onSuccess, onFail = _a.onFail, isPolling = _a.isPolling;
                callback()
                    .then(function (data) {
                    // 如果返回true，则继续轮询
                    var continuePolling = onSuccess === null || onSuccess === void 0 ? void 0 : onSuccess(data);
                    setState(function (prev) { return (__assign(__assign({}, prev), { data: data, pollingCount: prev.pollingCount + 1, error: null })); });
                    isPolling && continuePolling ? runPolling() : stopPolling();
                })
                    .catch(function (err) {
                    onFail === null || onFail === void 0 ? void 0 : onFail(err);
                    setState(function (prev) { return (__assign(__assign({}, prev), { pollingCount: prev.pollingCount + 1, error: err })); });
                    if (infoRef.current.retryCount > 0) {
                        infoRef.current.retryCount--;
                        runPolling();
                    }
                    else {
                        stopPolling();
                    }
                });
                return [2 /*return*/];
            });
        }); }, infoRef.current.interval);
    }, []);
    var startPolling = useCallback(function () {
        // 开始时重置重试次数
        infoRef.current.retryCount = retryCount;
        setState(function (prev) { return (__assign(__assign({}, prev), { pollingCount: 0, isPolling: true })); });
        runPolling();
    }, [retryCount, runPolling]);
    useEffect(function () {
        var info = infoRef.current;
        info.isMounted = true;
        startPolling();
        return function () {
            info.isMounted = false;
            stopPolling();
        };
    }, [startPolling]);
    return { isPolling: isPolling, pollingCount: pollingCount, result: data, error: error, startPolling: startPolling, stopPolling: stopPolling };
};
export default usePolling;
