import { useEffect, useRef } from 'react';
/**
 * 方便使用setTimeout的hook
 */
export default function useTimeout(callback, time) {
    if (time === void 0) { time = 300; }
    var callbackFn = useRef();
    callbackFn.current = callback;
    useEffect(function () {
        var timer = setTimeout(function () {
            callbackFn.current();
        }, time);
        return function () {
            clearTimeout(timer);
        };
    }, [time]);
}
