"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var useDebounceFn_1 = __importDefault(require("../useDebounceFn"));
/**
 * 仅对异步函数做简单处理，返回一个新的函数和loading、result、error等状态
 * @param asyncFunction
 * @param options.immediate 是否组件加载时自动执行
 * @param options.onResult 请求成功返回数据的回调，一般情况下直接.then后处理即可，但有时候希望自动同步状态，则可以配置onResult方法
 * @param options.debounceTime 设置值时自动进行debounce处理
 */
function useAsync(asyncFunction, _a) {
    var _this = this;
    var _b = _a === void 0 ? {} : _a, _c = _b.immediate, immediate = _c === void 0 ? false : _c, onResult = _b.onResult, debounceTime = _b.debounceTime;
    var _d = __read((0, react_1.useState)({
        status: 'idle',
        result: undefined,
        error: undefined,
    }), 2), _e = _d[0], result = _e.result, status = _e.status, error = _e.error, setState = _d[1];
    var unmountedRef = (0, react_1.useRef)(false);
    var onResultRef = (0, react_1.useRef)(onResult);
    var resultRef = (0, react_1.useRef)(result);
    var cbRef = (0, react_1.useRef)(asyncFunction);
    resultRef.current = result;
    cbRef.current = asyncFunction;
    var fetchingPromiseRef = (0, react_1.useRef)();
    if (onResultRef.current !== onResult)
        onResultRef.current = onResult;
    var originExector = (0, react_1.useCallback)(function () {
        var args = [];
        for (var _i = 0; _i < arguments.length; _i++) {
            args[_i] = arguments[_i];
        }
        // 如果正在请求中，则直接返回请求的promise
        if (fetchingPromiseRef.current) {
            return fetchingPromiseRef.current;
        }
        fetchingPromiseRef.current = (function () { return __awaiter(_this, void 0, void 0, function () {
            var res_1, error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        setState(function (prev) { return (__assign(__assign({}, prev), { status: 'loading' })); });
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, cbRef.current.apply(cbRef, __spreadArray([], __read(args), false))];
                    case 2:
                        res_1 = _a.sent();
                        fetchingPromiseRef.current = null;
                        setState(function (prev) { return (__assign(__assign({}, prev), { result: res_1, status: 'success' })); });
                        onResultRef.current && onResultRef.current(res_1);
                        return [2 /*return*/, res_1];
                    case 3:
                        error_1 = _a.sent();
                        fetchingPromiseRef.current = null;
                        setState(function (prev) { return (__assign(__assign({}, prev), { result: undefined, error: error_1, status: 'fail' })); });
                        Promise.reject(error_1);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        }); })();
        return fetchingPromiseRef.current;
    }, []);
    var _f = __read((0, useDebounceFn_1.default)(originExector, debounceTime), 1), debounceExector = _f[0];
    // 如果有debounceTime则使用debounce的函数
    var exector = (0, react_1.useMemo)(function () { return (debounceTime ? debounceExector : originExector); }, [debounceExector, debounceTime, originExector]);
    var mutate = (0, react_1.useCallback)(function (callback) { return __awaiter(_this, void 0, void 0, function () {
        var data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, callback(resultRef.current)];
                case 1:
                    data = _a.sent();
                    setState(function (prev) { return (__assign(__assign({}, prev), { result: data, status: 'mutate success' })); });
                    return [2 /*return*/];
            }
        });
    }); }, [setState]);
    (0, react_1.useEffect)(function () {
        !unmountedRef.current && immediate && exector();
        return function () {
            unmountedRef.current = true;
        };
        // 只在组件加载时执行一次
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    return [
        exector,
        {
            result: result,
            status: status,
            error: error,
            loading: status === 'loading' || status === 'mutate success',
            mutate: mutate,
        },
    ];
}
exports.default = useAsync;
