"use strict";
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
/**
 * 返回一个步进的数值，并提供一系列方法
 */
function useCounter(initialValue, options) {
    if (initialValue === void 0) { initialValue = 0; }
    if (options === void 0) { options = {}; }
    var _a = __read((0, react_1.useState)(initialValue), 2), counter = _a[0], setCounter = _a[1];
    var methods = (0, react_1.useMemo)(function () {
        var _a = options.min, min = _a === void 0 ? -Infinity : _a, _b = options.max, max = _b === void 0 ? Infinity : _b, _c = options.step, defaultStep = _c === void 0 ? 1 : _c;
        var setValue = function (nextValue) {
            var disposeValue = function (value) { return (value < min ? min : value > max ? max : value); };
            setCounter(function (value) { return disposeValue(typeof nextValue === 'function' ? nextValue(value) : nextValue); });
        };
        return {
            set: setValue,
            inc: function (step) {
                if (step === void 0) { step = defaultStep; }
                return setValue(function (value) { return value + step; });
            },
            dec: function (step) {
                if (step === void 0) { step = defaultStep; }
                return setValue(function (value) { return value - step; });
            },
            reset: function () { return setCounter(initialValue); },
        };
    }, [initialValue, options]);
    return [counter, methods];
}
exports.default = useCounter;
