"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
/**
 * 带有上次数据的useEffect
 */
function useEffectWithPrev(effect, deps) {
    var prevRef = (0, react_1.useRef)(deps);
    (0, react_1.useEffect)(function () {
        if (!deps) {
            return effect(prevRef.current);
        }
        var prev = prevRef.current;
        prevRef.current = deps;
        if (deps.length !== prev.length || deps.some(function (dep, index) { return dep !== prev[index]; })) {
            return effect(prev);
        }
    });
}
exports.default = useEffectWithPrev;
