export declare type Subscription<T = any> = (value: T, ...args: any[]) => void;
export declare type EventType = string | symbol;
export interface EventBusOptions {
    autoFireLatest?: boolean;
}
export declare class EventBus<T = any> {
    private eventContainer;
    cacheLatest: Map<EventType, any>;
    autoFireLatest: boolean;
    constructor(options?: EventBusOptions);
    publish: (type: EventType, payload?: T) => void;
    subscribe: (type: EventType, handler: Subscription<T>) => any;
    subscribeOnce(type: EventType, handler: Subscription<T>): void;
    unSubscribe: (type: EventType, subscription: Subscription<T>) => this;
    clearSubscriptions(type: EventType): void;
}
