export interface HistoryStock<T> {
    snapshot: T;
    timestamp: number;
}
export interface Options<Raw, Serialized = Raw> {
    max?: number;
    dump?: (source: Raw) => Serialized;
    parse?: <Raw, Serialized = Raw>(value: Serialized) => Raw;
    onUpdate?: (value: Raw, dump: HistoryStock<Serialized>) => void;
}
export default class HistoryState<Raw, Serialized = Raw> {
    source: any;
    last: HistoryStock<any>;
    undoList: HistoryStock<any>[];
    redoList: HistoryStock<any>[];
    max: number;
    dump: (v: Raw) => Serialized;
    parse: <Raw, Serialized = Raw>(sourceDump: Serialized) => Raw;
    onUpdate: (value: Raw, dump: HistoryStock<Serialized>) => void;
    constructor(options?: Options<Raw, Serialized>);
    get canUndo(): boolean;
    get canRedo(): boolean;
    get history(): HistoryStock<any>[];
    createHistoryItem(newSource: Raw): {
        snapshot: Serialized;
        timestamp: number;
    };
    undo(): void;
    redo(): void;
    clear(): void;
    push(newSource: Raw): void;
    reset(): void;
    private _changeState;
    getHistory(): HistoryStock<any>[];
    getUndoList(): HistoryStock<any>[];
    getRedoList(): HistoryStock<any>[];
    getCanUndo(): boolean;
    getCanRedo(): boolean;
    getSource(): any;
    getLast(): HistoryStock<any>;
}
