"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var utils_1 = require("../utils");
var useMethods_1 = __importDefault(require("../useMethods"));
var checkedMapReducers = function (state) {
    if (state === void 0) { state = {}; }
    return {
        setChecked: function (payload) {
            var _a;
            return (__assign(__assign({}, state), (_a = {}, _a[payload.key] = payload.checked, _a)));
        },
        toggleChecked: function (payload) {
            var _a;
            var _b;
            return (__assign(__assign({}, state), (_a = {}, _a[payload.key] = (_b = payload.checked) !== null && _b !== void 0 ? _b : !state[payload.key], _a)));
        },
        setAllChecked: function (checked) { return Object.keys(state).reduce(function (prev, curr) {
            var _a;
            return (__assign(__assign({}, prev), (_a = {}, _a[curr] = checked, _a)));
        }, {}); },
        clearChecked: function (state) {
            if (state === void 0) { state = {}; }
            return Object.keys(state).reduce(function (prev, curr) {
                var _a;
                return (__assign(__assign({}, prev), (_a = {}, _a[curr] = false, _a)));
            }, {});
        },
        expandCheckedMap: function (payload) {
            if (payload === void 0) { payload = []; }
            return payload.reduce(function (prev, curr) {
                var _a;
                return (__assign(__assign({}, prev), (_a = {}, _a[curr.id] = (0, utils_1.isNil)(prev[curr.id]) ? false : prev[curr.id], _a)));
            }, state);
        },
    };
};
/**
 * 列表的多选hooks，选择，全选，已选
 * @param {array} items 所有id
 * @param {array} defaultSelecteds 当前已选中ids
 */
function useListChecked(items, defaultSelecteds) {
    if (items === void 0) { items = []; }
    if (defaultSelecteds === void 0) { defaultSelecteds = []; }
    var _a = __read((0, useMethods_1.default)(checkedMapReducers, items.reduce(function (prev, curr) {
        var _a;
        return (__assign(__assign({}, prev), (_a = {}, _a[curr.id] = defaultSelecteds.includes(curr.id), _a)));
    }, {})), 2), checkedMap = _a[0], methods = _a[1];
    var _b = (0, react_1.useMemo)(function () { return ({
        isAllChecked: !!Object.values(checkedMap).length && !Object.values(checkedMap).some(function (v) { return !v; }),
        // 当前选中的key列表
        checkedIds: Object.keys(checkedMap).filter(function (key) { return !!checkedMap[key]; }),
        // 切换全选状态或设置为指定的全选状态
        toggleAllChecked: function (checked) { return methods.setAllChecked(checked !== undefined ? checked : !isAllChecked); },
    }); }, 
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [checkedMap]), isAllChecked = _b.isAllChecked, checkedIds = _b.checkedIds, toggleAllChecked = _b.toggleAllChecked;
    var _c = (0, react_1.useMemo)(function () {
        return {
            setChecked: function (key, checked) { return methods.setChecked({ key: key, checked: checked }); },
            toggleChecked: function (key, checked) { return methods.toggleChecked({ key: key, checked: checked }); },
            // 清空选中
            clearChecked: function () { return methods.clearChecked(); },
        };
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []), setChecked = _c.setChecked, clearChecked = _c.clearChecked, toggleChecked = _c.toggleChecked;
    // ids列表变化时, 更新map数据, 动态载入下一页数据等时更新checkMap
    // useEffect(() => {
    // methods.expandCheckedMap(items)
    // eslint-disable-next-line react-hooks/exhaustive-deps
    // }, [items])
    return {
        isAllChecked: isAllChecked,
        checkedIds: checkedIds,
        setChecked: setChecked,
        toggleChecked: toggleChecked,
        toggleAllChecked: toggleAllChecked,
        clearChecked: clearChecked,
        updateItems: methods.expandCheckedMap,
    };
}
exports.default = useListChecked;
