"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.transformListToFoldList = exports.transformListToPartition = exports.transformListToGroup = exports.transformListToMap = exports.transformListToTree = void 0;
var utils_1 = require("../utils");
function transformListToTree(data, _a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.rootParentId, rootParentId = _c === void 0 ? undefined : _c, _d = _b.parentId, parentId = _d === void 0 ? 'pid' : _d, _e = _b.id, id = _e === void 0 ? 'id' : _e, _f = _b.children, children = _f === void 0 ? 'children' : _f;
    var cloneData = JSON.parse(JSON.stringify(data));
    var dataMap = transformListToMap(data);
    return cloneData.filter(function (curr) {
        var childrenItem = cloneData.filter(function (child) { return curr[id] === child[parentId]; });
        if (childrenItem.length) {
            curr[children] = childrenItem;
        }
        return curr[parentId] === rootParentId || !curr[parentId] || (0, utils_1.isNil)(dataMap[curr[parentId]]);
    });
}
exports.transformListToTree = transformListToTree;
function transformListToMap(data, _a) {
    var _b = _a === void 0 ? {} : _a, _c = _b.key, key = _c === void 0 ? 'id' : _c;
    return data.reduce(function (prev, cur) {
        prev[cur[key]] = cur;
        return prev;
    }, {});
}
exports.transformListToMap = transformListToMap;
function transformListToGroup(data, _a) {
    if (data === void 0) { data = []; }
    var _b = _a === void 0 ? {} : _a, groupKey = _b.groupKey;
    var groupByDataMap = {};
    if (groupKey) {
        data.forEach(function (item) {
            groupByDataMap[item[groupKey]] = __spreadArray(__spreadArray([], __read((groupByDataMap[item[groupKey]] || [])), false), [item], false).filter(function (v) { return !!v; });
        });
        return groupByDataMap;
    }
    else {
        return data;
    }
}
exports.transformListToGroup = transformListToGroup;
function transformListToPartition(data, _a) {
    if (data === void 0) { data = []; }
    var _b = _a === void 0 ? {} : _a, groupKey = _b.groupKey;
    var groupMap = transformListToGroup(data, { groupKey: groupKey });
    return Object.values(groupMap);
}
exports.transformListToPartition = transformListToPartition;
/**
 * 字段展开
 */
function transformListToFoldList(data, _a) {
    if (data === void 0) { data = []; }
    var _b = _a === void 0 ? {} : _a, fields = _b.fields;
    return fields.reduce(function (prev, field) { return __spreadArray(__spreadArray([], __read(prev), false), __read(foldData(data, { field: field })), false); }, []);
}
exports.transformListToFoldList = transformListToFoldList;
function foldData(data, _a) {
    if (data === void 0) { data = []; }
    var field = _a.field;
    return data.reduce(function (prev, item) {
        var fieldValue = item.field, restData = __rest(item, ["field"]);
        return __spreadArray(__spreadArray([], __read(prev), false), [__assign({ key: field, value: fieldValue }, restData)], false);
    }, []);
}
var transform = {
    tree: transformListToTree,
    obj: transformListToMap,
    group: transformListToGroup,
    partition: transformListToPartition,
    fold: transformListToFoldList,
};
exports.default = transform;
