"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
require("intersection-observer");
var __1 = __importDefault(require(".."));
var fetchParams = { pageNo: 1, pageSize: 5 };
var mockData = new Array(30).fill(0).map(function (v, i) { return ({ id: i, value: i }); });
var fetchData = function (params) {
    var query = __assign(__assign({}, fetchParams), (params || {}));
    return new Promise(function (resolve) {
        setTimeout(function () {
            var start = (query.pageNo - 1) * query.pageSize;
            var data = mockData.slice(start, start + query.pageSize);
            resolve({ data: data, total: mockData.length, hasMore: query.pageNo < +(mockData.length / query.pageSize).toFixed(0) });
        }, 500);
    });
};
function Demo() {
    var _a = (0, __1.default)(fetchData, {
        autoLoad: true,
        initialQuery: { pageSize: 10 },
        isMerge: true,
    }), listData = _a.listData, loading = _a.loading, loadNextPage = _a.loadNextPage, hasMore = _a.hasMore;
    var rootRef = (0, react_1.useRef)();
    var targetRef = (0, react_1.useRef)();
    (0, react_1.useEffect)(function () {
        var io = new IntersectionObserver(function (entries) {
            entries.forEach(function (entry) {
                entry.isIntersecting && hasMore && loadNextPage();
            });
        }, {
            root: rootRef.current || null,
            rootMargin: "0px",
            threshold: 0,
        });
        io.observe(targetRef.current);
        return function () {
            io.disconnect();
        };
    }, [hasMore, loadNextPage]);
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("h2", null, "\u6EDA\u52A8\u52A0\u8F7D\u793A\u4F8B"),
        react_1.default.createElement("div", { style: { border: 'solid 1px', height: '100px', overflow: 'scroll', padding: 0 }, ref: rootRef },
            react_1.default.createElement("ul", { style: { padding: 0 } }, listData.map(function (item, i) { return (react_1.default.createElement("li", { style: { listStyleType: 'none', borderBottom: 'solid 0.5px #bbb' }, key: i },
                "\u7B2C",
                item.value,
                "\u6761")); })),
            react_1.default.createElement("div", { ref: targetRef }, loading ? 'loading' : ''))));
}
exports.default = Demo;
