"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
/**
 * 带有上次数据的useMemo
 */
function useMemoWithPrev(nextCreate, deps) {
    var prevRef = (0, react_1.useRef)({ deps: deps, value: undefined, nextCreate: nextCreate });
    prevRef.current.nextCreate = nextCreate;
    return (0, react_1.useMemo)(function () {
        var current = prevRef.current.nextCreate(prevRef.current.deps, prevRef.current.value);
        prevRef.current.deps = deps;
        prevRef.current.value = current;
        return current;
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, deps);
}
exports.default = useMemoWithPrev;
