"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var immer_1 = __importDefault(require("immer"));
var react_1 = require("react");
function useMethodsImmer(methods, initialState, initializer, Options) {
    if (initializer === void 0) { initializer = undefined; }
    if (Options === void 0) { Options = {}; }
    var immerReducer = (0, react_1.useMemo)(function () {
        return function (state, action) {
            return (0, immer_1.default)(state, function (draft) {
                var method = methods[action.type];
                if (method) {
                    return method.apply(void 0, __spreadArray([draft], __read((action.args || [])), false));
                }
            }, Options.patchListener);
        };
    }, [methods, Options.patchListener]);
    var _a = __read((0, react_1.useReducer)(immerReducer, initialState, initializer), 2), state = _a[0], dispatch = _a[1];
    var actions = (0, react_1.useMemo)(function () {
        var dispatchMethod = function () {
            var _a;
            var args = [];
            for (var _i = 0; _i < arguments.length; _i++) {
                args[_i] = arguments[_i];
            }
            dispatch(typeof args[0] === 'string' ? { type: args[0], args: args.slice(1) } : { type: (_a = args[0]) === null || _a === void 0 ? void 0 : _a.type, args: args });
        };
        return Object.keys(methods).reduce(function (prev, type) {
            var _a;
            return (__assign(__assign({}, prev), (_a = {}, _a[type] = function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                return dispatch({ type: type, args: args });
            }, _a)));
        }, { dispatch: dispatchMethod });
        // 因为使用immer，此处并不需要监听state变动，methods也应该是静态配置好的，不会动态增加
        // 但是actions下的reducer应当是纯函数，不然会造成引用的其他state不是最新值
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    return [state, actions];
}
exports.default = useMethodsImmer;
