declare type Callback = (...args: any[]) => Promise<any>;
interface Options {
    interval?: number;
    retryCount?: number;
    onSuccess?: (data: any) => boolean | void;
    onFail?: (data: any) => void;
}
/**
 * 轮询一个请求
 * @param callback
 * @param options
 * @returns
 */
declare const usePolling: (callback: Callback, options: Options) => {
    isPolling: boolean;
    pollingCount: number;
    result: any;
    error: any;
    startPolling: () => void;
    stopPolling: () => void;
};
export default usePolling;
